
###### YOU NEED TO RUN SEPERATE SCRIPT WITH SENSITIVE INFO TO GET user name and decryption keys into the environment first


### before you run this, back up the last run, by saving all unzipped files in a folder with the date in Kenya folder.


### install packages #######

#if (!requireNamespace("remotes")) install.packages("remotes")
# Full install
#remotes::install_github(
#  "ropensci/ruODK@main", 
#  dependencies = TRUE, 
#  upgrade = "always",
#  build_vignettes = TRUE)

### set directories####

#usethis::edit_r_environ(scope = "user")

#SET WORKING DIRECTORY setwd


# SET YOUR PATH mypath 

#SET LOCAL DIRECTORY local

#SET EXTERNAL DIRECTORY exdir

library(ruODK)



#### check access to the server with a dummy form#####
ruODK::ru_setup(
  url =ODKC_URL, 
  un = ODKC_UN, 
  pw = ODKC_pw,
  pid = "1",
  pp = ODKC_pp,
  fid = "Demographics_Kenya_EN_V0",
  tz = "UTC",
  verbose = TRUE
)

se<- ruODK::submission_export(
  local_dir = "local",
  overwrite = TRUE,
  media = TRUE,
  repeats = TRUE,
  pid = get_default_pid(),
  fid = get_default_fid(),
  url = get_default_url(),
  un = get_default_un(),
  pw = get_default_pw(),
  pp = get_default_pp(),
  retries = get_retries(),
  odkc_version = get_default_odkc_version(),
  verbose = get_ru_verbose())

unzip(zipfile=se,exdir="exdir")




#### check lists and forms##
ruODK::project_list()
ruODK::form_list()

### with any given form (change above in the ruodk::ru_setup) you can individually check the submission list here
#ruODK::submission_list()



##### the following loop will download and unzip each form and submissions within your list. break down for each country####
#need a folder named the same for each country in working directory- SA, Peru, Kenya, Haiti.


### set up loop for Kenya

### export form list, or use individual ones stored in your directory. In this project, separate out for each country#####


forms<-read.csv("Kenya.form.list.csv")
forms<-as.vector(forms[,1])
forms
##start the loop for i in forms.small##

### set i as a number to check a single form, number corresponds to a position in excel list###
#i=1

ODKC_FID= forms[i]

### check forms i has names in "" so it can be read #####
forms[i]
set.seed(123)


for (i in 1:length(forms)) {
  ruODK::ru_setup(
    url =ODKC_URL, 
    un = ODKC_UN, 
    pw = ODKC_pw,
    pid = "1",
    pp = ODKC_pp,
    fid = forms[i],
    tz = "UTC",
    verbose = TRUE
  )
  se<- ruODK::submission_export(
    local_dir = "local",
    overwrite = TRUE,
    media = TRUE,
    repeats = TRUE,
    pid = get_default_pid(),
    fid = get_default_fid(),
    url = get_default_url(),
    un = get_default_un(),
    pw = get_default_pw(),
    pp = get_default_pp(),
    retries = get_retries(),
    odkc_version = get_default_odkc_version(),
    verbose = get_ru_verbose())
  
  unzip(zipfile=se,exdir="exdir")
}


#######RUN AFTER REMOVED more ten files~~~~~~~~~~

###### Remove duplicates in Files
setwd("wd")

mypath <- "mypath"
filelist <- list.files(path = mypath, pattern = ".csv")
filelist <- as.vector(filelist)
filelist
library(dplyr)
set.seed(123)

for (i in 1:length(filelist)) {
  print(filelist[i])
  temp <- read.csv(paste0(mypath,"/", filelist[i]))
  remove_dupes<- temp %>% 
    # Base the removal on the "imei" column
    distinct(imei, .keep_all = TRUE)
  write.csv(remove_dupes,filelist[i])
}
  


